/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.tables.records.VCoreCombinedLabelRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreCombinedLabel extends TableImpl<VCoreCombinedLabelRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_combined_label</code>
     */
    public static final VCoreCombinedLabel V_CORE_COMBINED_LABEL = new VCoreCombinedLabel();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreCombinedLabelRecord> getRecordType() {
        return VCoreCombinedLabelRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_combined_label.unique_name</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.dn</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.isocode</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.is_variable</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, Boolean> IS_VARIABLE = createField(DSL.name("is_variable"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.hier_lang</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.prefix</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> PREFIX = createField(DSL.name("prefix"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.vargroup_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> VARGROUP_LABEL = createField(DSL.name("vargroup_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.unit_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> UNIT_LABEL = createField(DSL.name("unit_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.variable_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> VARIABLE_LABEL = createField(DSL.name("variable_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.prepared_unit</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> PREPARED_UNIT = createField(DSL.name("prepared_unit"), SQLDataType.CLOB, this, "");

    /**
     * The column
     * <code>common_dd.v_core_combined_label.prepared_short_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> PREPARED_SHORT_LABEL = createField(DSL.name("prepared_short_label"), SQLDataType.CLOB, this, "");

    /**
     * The column
     * <code>common_dd.v_core_combined_label.prepared_medium_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> PREPARED_MEDIUM_LABEL = createField(DSL.name("prepared_medium_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.prepared_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> PREPARED_LABEL = createField(DSL.name("prepared_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.crf_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> CRF_LABEL = createField(DSL.name("crf_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.short_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> SHORT_LABEL = createField(DSL.name("short_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.medium_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> MEDIUM_LABEL = createField(DSL.name("medium_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_combined_label.full_label</code>.
     */
    public final TableField<VCoreCombinedLabelRecord, String> FULL_LABEL = createField(DSL.name("full_label"), SQLDataType.CLOB, this, "");

    private VCoreCombinedLabel(Name alias, Table<VCoreCombinedLabelRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreCombinedLabel(Name alias, Table<VCoreCombinedLabelRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_combined_label" as  WITH x(unique_name, dn, isocode, is_variable, hier_lang, prefix_short, vargroup_label, variable_label, unit_label, prepared_label, prepared_unit, prepared_medium_label, prepared_short_label) AS (
                SELECT h.unique_name,
                   h.dn,
                   tc.isocode,
                   (v.key_variable IS NOT NULL) AS "?column?",
                   h.hier_lang,
                   p.prefix_short,
                   tg.value AS vargroup_label,
                   tc.value AS variable_label,
                   tu.value AS unit_label,
                       CASE
                           WHEN (tg.value = tc.value) THEN COALESCE(tc.value, tg.value)
                           ELSE btrim(format('%s %s'::text, tg.value, tc.value))
                       END AS prepared_label,
                       CASE
                           WHEN (tu.value IS NULL) THEN ''::text
                           ELSE btrim(format('[%s]'::text, tu.value))
                       END AS prepared_unit,
                   tl.value AS prepared_medium_label,
                   ts.value AS prepared_short_label
                  FROM (((((((((common_dd.t_core_element_hierarchy h
                    LEFT JOIN common_dd.v_core_element_prefix_short p ON ((p.key_element = h.key_element)))
                    LEFT JOIN common_dd.t_core_element_hierarchy g ON (((g.key_element = h.key_parent_element) AND (g.key_element IN ( SELECT t_core_vargrp.fk_key_element
                          FROM common_dd.t_core_vargrp)))))
                    LEFT JOIN common_dd.t_core_translation tc ON (((tc.fk_trans_key = h.hier_lang) AND (tc.category = 'crf'::common_dd.enum_trans_category))))
                    LEFT JOIN common_dd.t_core_translation tg ON (((tg.fk_trans_key = g.hier_lang) AND (tg.category = 'crf'::common_dd.enum_trans_category) AND (tg.isocode = tc.isocode))))
                    LEFT JOIN common_dd.t_core_translation tl ON (((tl.fk_trans_key = h.hier_lang) AND (tl.category = 'medium'::common_dd.enum_trans_category) AND (tl.isocode = tc.isocode))))
                    LEFT JOIN common_dd.t_core_translation ts ON (((ts.fk_trans_key = h.hier_lang) AND (ts.category = 'short'::common_dd.enum_trans_category) AND (ts.isocode = tc.isocode))))
                    LEFT JOIN common_dd.t_core_variable v ON ((v.key_variable = h.key_element)))
                    LEFT JOIN common_dd.t_core_unit u ON ((u.pk = v.fk_unit)))
                    LEFT JOIN common_dd.t_core_translation tu ON (((tu.fk_trans_key = u.fk_trans_key) AND (tc.isocode = tu.isocode))))
               ), fin(unique_name, isocode, crf_label, short_label, medium_label, full_label) AS (
                SELECT foo.unique_name,
                   foo.isocode,
                   btrim(format('%s %s'::text, foo.variable_label, foo.prepared_unit)) AS crf_label,
                   btrim(format('%s%s%s'::text, foo.prefix_short,
                       CASE
                           WHEN (foo.prefix_short_filled AND foo.prepared_short_filled) THEN ': '::text
                           ELSE ' '::text
                       END, foo.prepared_short_label)) AS short_label,
                   btrim(format('%s%s%s %s'::text, foo.prefix_short,
                       CASE
                           WHEN (foo.prefix_short_filled AND (foo.prepared_medium_filled OR foo.prepared_unit_filled)) THEN ': '::text
                           ELSE ' '::text
                       END, foo.prepared_medium_label, foo.prepared_unit)) AS medium_label,
                   btrim(format('%s%s%s %s'::text, foo.prefix_short,
                       CASE
                           WHEN (foo.prefix_short_filled AND (foo.prepared_label_filled OR foo.prepared_unit_filled)) THEN ': '::text
                           ELSE ' '::text
                       END, foo.prepared_label, foo.prepared_unit)) AS full_label
                  FROM ( SELECT x_1.unique_name,
                           x_1.dn,
                           x_1.isocode,
                           x_1.is_variable,
                           x_1.hier_lang,
                           x_1.prefix_short,
                           x_1.vargroup_label,
                           x_1.variable_label,
                           x_1.unit_label,
                           x_1.prepared_label,
                           x_1.prepared_unit,
                           x_1.prepared_medium_label,
                           x_1.prepared_short_label,
                           (x_1.prefix_short IS NOT NULL) AS prefix_short_filled,
                           (x_1.prepared_short_label IS NOT NULL) AS prepared_short_filled,
                           (x_1.prepared_medium_label IS NOT NULL) AS prepared_medium_filled,
                           (x_1.prepared_label IS NOT NULL) AS prepared_label_filled,
                           (x_1.prepared_unit <> ''::text) AS prepared_unit_filled
                          FROM x x_1) foo
               )
        SELECT x.unique_name,
           x.dn,
           x.isocode,
           x.is_variable,
           x.hier_lang,
           x.prefix_short AS prefix,
           x.vargroup_label,
           x.unit_label,
           x.variable_label,
           x.prepared_unit,
           x.prepared_short_label,
           x.prepared_medium_label,
           x.prepared_label,
           fin.crf_label,
           fin.short_label,
           fin.medium_label,
           fin.full_label
          FROM (x
            JOIN fin ON (((x.unique_name = fin.unique_name) AND (x.isocode = fin.isocode))))
         ORDER BY x.unique_name, x.dn, x.isocode;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_combined_label</code> table
     * reference
     */
    public VCoreCombinedLabel(String alias) {
        this(DSL.name(alias), V_CORE_COMBINED_LABEL);
    }

    /**
     * Create an aliased <code>common_dd.v_core_combined_label</code> table
     * reference
     */
    public VCoreCombinedLabel(Name alias) {
        this(alias, V_CORE_COMBINED_LABEL);
    }

    /**
     * Create a <code>common_dd.v_core_combined_label</code> table reference
     */
    public VCoreCombinedLabel() {
        this(DSL.name("v_core_combined_label"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreCombinedLabel as(String alias) {
        return new VCoreCombinedLabel(DSL.name(alias), this);
    }

    @Override
    public VCoreCombinedLabel as(Name alias) {
        return new VCoreCombinedLabel(alias, this);
    }

    @Override
    public VCoreCombinedLabel as(Table<?> alias) {
        return new VCoreCombinedLabel(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreCombinedLabel rename(String name) {
        return new VCoreCombinedLabel(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreCombinedLabel rename(Name name) {
        return new VCoreCombinedLabel(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreCombinedLabel rename(Table<?> name) {
        return new VCoreCombinedLabel(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreCombinedLabel where(Condition condition) {
        return new VCoreCombinedLabel(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreCombinedLabel where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreCombinedLabel where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreCombinedLabel where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreCombinedLabel where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreCombinedLabel where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreCombinedLabel where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreCombinedLabel where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreCombinedLabel whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreCombinedLabel whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
